From 37679639f48b592a8e38e2d8e8e1ab5b2f5546b7 Mon Sep 17 00:00:00 2001
From: Paul Eggert <eggert@cs.ucla.edu>
Date: Tue, 2 Feb 2016 09:16:24 -0800
Subject: [PATCH] Port malloc.h hygiene fix to LTO

* src/alloc.c (__malloc_initialize_hook):
Make it externally visible (Bug#22522).
---
 src/alloc.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/src/alloc.c b/src/alloc.c
index 57ef4c5..b40c1f3 100644
--- a/src/alloc.c
+++ b/src/alloc.c
@@ -157,10 +157,12 @@ malloc_initialize_hook (void)
     }
 }
 
+/* Declare the malloc initialization hook, which runs before 'main' starts.
+   EXTERNALLY_VISIBLE works around Bug#22522.  */
 # ifndef __MALLOC_HOOK_VOLATILE
 #  define __MALLOC_HOOK_VOLATILE
 # endif
-voidfuncptr __MALLOC_HOOK_VOLATILE __malloc_initialize_hook
+voidfuncptr __MALLOC_HOOK_VOLATILE __malloc_initialize_hook EXTERNALLY_VISIBLE
   = malloc_initialize_hook;
 
 #endif
-- 
2.5.0

